using BMA.EHR.Application.Repositories.Reports;
using BMA.EHR.Domain.Common;
using BMA.EHR.Domain.Models.Insignias;
using DocumentFormat.OpenXml.Drawing;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Swashbuckle.AspNetCore.Annotations;
using Telerik.Reporting;
using Telerik.Reporting.Processing;

namespace BMA.EHR.Report.Service.Controllers
{
    [Route("api/v{version:apiVersion}/report/insignia")]
    [ApiVersion("2.0")]
    [ApiController]
    [Produces("application/json")]
    //[Authorize]
    [SwaggerTag("API รายงานระบบเครื่องราชอิสริยาภรณ์")]
    public class InsigniaReportController : BaseController
    {
        #region " Fields "

        private readonly IWebHostEnvironment _hostingEnvironment;
        private readonly IConfiguration _configuration;
        private readonly InsigniaReportRepository _repository;
        private readonly GenericReportGenerator _reportGenerator;


        #endregion

        #region " Constuctor and Destructor "

        public InsigniaReportController(IWebHostEnvironment hostingEnvironment, IConfiguration configuration, InsigniaReportRepository repository, GenericReportGenerator reportGenerator)
        {

            _hostingEnvironment = hostingEnvironment;
            _configuration = configuration;
            _repository = repository;
            _reportGenerator = reportGenerator;
        }

        #endregion

        #region " Methods "

        #region 39-แบบ ขร1 บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ ข้าราชการ ชั้นสายสะพาย
        /// <summary>
        /// 39-แบบ ขร1 บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ ข้าราชการ ชั้นสายสะพาย
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("39/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia39ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {
                var data = await _repository.GetKhr1Report(id);
                var total = await _repository.GetKhr1TotalReport(id);
                var YearInsignalPeriod = await _repository.GetYearInsigniaPeriod(id);
                var TwoYearInsignalPeriod = await _repository.Get2YearInsigniaPeriod(id);
                var Date = await _repository.GetDateInsigniaPeriod(id);
                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }
                
                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"39-แบบ ขร1 บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ ข้าราชการ ชั้นสายสะพาย.trdp");

                ReportPackager reportPacker = new ReportPackager();
                Telerik.Reporting.Report? report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPacker.UnpackageDocument(sourceStream);
                }

                report.ReportParameters["YearInsigniaPeriod"].Value = YearInsignalPeriod;
                report.ReportParameters["TwoYearInsignalPeriod"].Value = TwoYearInsignalPeriod;
                report.ReportParameters["EndDate"].Value = Date.GetType().GetProperty("EndDate").GetValue(Date);

                var _Khr1List = new List<dynamic>();
                foreach (var _data in data)
                {
                    _Khr1List.Add(new
                    {
                        //RowNo = _data.GetType().GetProperty("RowNo").GetValue(_data),
                        RowNo = _Khr1List.Count + 1,
                        DepartmentName = _data.GetType().GetProperty("DepartmentName").GetValue(_data),
                        G1Male = _data.GetType().GetProperty("G1Male").GetValue(_data),
                        G1Female = _data.GetType().GetProperty("G1Female").GetValue(_data),
                        G2Male = _data.GetType().GetProperty("G2Male").GetValue(_data),
                        G2Female = _data.GetType().GetProperty("G2Female").GetValue(_data),
                        G3Male = _data.GetType().GetProperty("G3Male").GetValue(_data),
                        G3Female = _data.GetType().GetProperty("G3Female").GetValue(_data),
                        G4Male = _data.GetType().GetProperty("G4Male").GetValue(_data),
                        G4Female = _data.GetType().GetProperty("G4Female").GetValue(_data),
                        G5Male = _data.GetType().GetProperty("G5Male").GetValue(_data),
                        G5Female = _data.GetType().GetProperty("G5Female").GetValue(_data),
                        Remark = _data.GetType().GetProperty("Remark").GetValue(_data),
                    });
                }
                var tbl = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table1"];
                tbl.DataSource = _Khr1List;
                var tbl2 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table2"];
                tbl2.DataSource = total;

                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();
                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report,
                };
                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport($"{exportType}", instanceReportSource, deviceInfo);
                return File(result.DocumentBytes, mimeType, $"แบบ ขร1.{exportType.Trim().ToLower()}");
            }
            catch
            {
                throw;
            }
        }
        #endregion

        #region 40-แบบ ขร2 บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ ข้าราชการ ชั้นต่ำกว่าสายสะพาย	
        /// <summary>
        /// 40-แบบ ขร2 บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ ข้าราชการ ชั้นต่ำกว่าสายสะพาย	
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("40/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia40ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {
                var data = await _repository.GetKhr2Report(id);
                var total = await _repository.GetKhr2TotalReport(id);
                var YearInsignalPeriod = await _repository.GetYearInsigniaPeriod(id);
                var TwoYearInsignalPeriod = await _repository.Get2YearInsigniaPeriod(id);
                var Date = await _repository.GetDateInsigniaPeriod(id);
                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }

                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"40-แบบ ขร2 บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ ข้าราชการ ชั้นต่ำกว่าสายสะพาย.trdp");
                ReportPackager reportPacker = new ReportPackager();
                Telerik.Reporting.Report? report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPacker.UnpackageDocument(sourceStream);
                }

                report.ReportParameters["YearInsigniaPeriod"].Value = YearInsignalPeriod;
                report.ReportParameters["TwoYearInsignalPeriod"].Value = TwoYearInsignalPeriod;
                report.ReportParameters["EndDate"].Value = Date.GetType().GetProperty("EndDate").GetValue(Date);

                var _Khr2List = new List<dynamic>();
                foreach (var _data in data)
                {
                    _Khr2List.Add(new
                    {
                        RowNo = _Khr2List.Count+1,
                        DepartmentName = _data.GetType().GetProperty("DepartmentName").GetValue(_data),
                        G1Male = _data.GetType().GetProperty("G1Male").GetValue(_data),
                        G1Female = _data.GetType().GetProperty("G1Female").GetValue(_data),
                        G2Male = _data.GetType().GetProperty("G2Male").GetValue(_data),
                        G2Female = _data.GetType().GetProperty("G2Female").GetValue(_data),
                        G3Male = _data.GetType().GetProperty("G3Male").GetValue(_data),
                        G3Female = _data.GetType().GetProperty("G3Female").GetValue(_data),
                        G4Male = _data.GetType().GetProperty("G4Male").GetValue(_data),
                        G4Female = _data.GetType().GetProperty("G4Female").GetValue(_data),
                        G5Male = _data.GetType().GetProperty("G5Male").GetValue(_data),
                        G5Female = _data.GetType().GetProperty("G5Female").GetValue(_data),
                        G6Male = _data.GetType().GetProperty("G1Male").GetValue(_data),
                        G6Female = _data.GetType().GetProperty("G1Female").GetValue(_data),
                        G7Male = _data.GetType().GetProperty("G1Male").GetValue(_data),
                        G7Female = _data.GetType().GetProperty("G1Female").GetValue(_data),
                        G8Male = _data.GetType().GetProperty("G1Male").GetValue(_data),
                        G8Female = _data.GetType().GetProperty("G1Female").GetValue(_data),
                        G9Male = _data.GetType().GetProperty("G1Male").GetValue(_data),
                        G9Female = _data.GetType().GetProperty("G1Female").GetValue(_data),
                        Remark = _data.GetType().GetProperty("Remark").GetValue(_data),
                    });
                }
                var tbl1 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table1"];
                tbl1.DataSource = _Khr2List;
                var tbl2 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table2"];
                tbl2.DataSource = total;

                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();
                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report,
                };
                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport($"{exportType}", instanceReportSource, deviceInfo);
                return File(result.DocumentBytes, mimeType, $"แบบ ขร2.{exportType.Trim().ToLower()}");
            }
            catch
            {
                throw;
            }
        }
        #endregion

        #region 41-แบบ ขร3 บัญชีรายชื่อข้าราชการผู้ขอพระราชทานเครื่องราชฯ
        /// <summary>
        /// 41-แบบ ขร3 บัญชีรายชื่อข้าราชการผู้ขอพระราชทานเครื่องราชฯ
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("41/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia41ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {
                var data = await _repository.GetKhr3Report(id);
                var YearInsignalPeriod = await _repository.GetYearInsigniaPeriod(id);
                var TwoYearInsignalPeriod = await _repository.Get2YearInsigniaPeriod(id);
                var Date = await _repository.GetDateInsigniaPeriod(id);
                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }
                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"41-แบบ ขร3 บัญชีรายชื่อข้าราชการผู้ขอพระราชทานเครื่องราชฯ.trdp");
                ReportPackager reportPacker = new ReportPackager();
                Telerik.Reporting.Report? report = null;

        

                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPacker.UnpackageDocument(sourceStream);
                }

                report.ReportParameters["YearInsigniaPeriod"].Value = YearInsignalPeriod;
                report.ReportParameters["TwoYearInsignalPeriod"].Value = TwoYearInsignalPeriod;
                report.ReportParameters["EndDate"].Value = Date.GetType().GetProperty("EndDate").GetValue(Date);
                //int count = ((IEnumerable<object>)data).Count();
                //int counter = 0;
                //var _Khr3LeftList = new List<dynamic>();
                //var _Khr3RightList = new List<dynamic>();
                //foreach(var _data in data)
                //{
                //    _Khr3LeftList.Add(new
                //    {
                //        RowNo = _Khr3LeftList.Count +1,
                //        FullName = _data.GetType().GetProperty("FullName").GetValue(_data),
                //        OCName = _data.GetType().GetProperty("OCName").GetValue(_data),
                //        InsigniaName = _data.GetType().GetProperty("InsigniaName").GetValue(_data),

                //    });
                //}
                //var tbl1 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table1"];
                //tbl1.DataSource = _Khr3LeftList;

                //var tbl2 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table2"];
                //tbl2.DataSource = _Khr3RightList;

                report.DataSource = data;

                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();
                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report,
                };
                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport($"{exportType}", instanceReportSource, deviceInfo);

                return File(result.DocumentBytes, mimeType, $"แบบ ขร3.{exportType.Trim().ToLower()}");
            }
            catch
            {
                throw;
            }
        }
        #endregion

        #region 42-แบบ ขร4 บัญชีแสดงคุณสมบัติของข้าราชการซึ่งเสนอขอเครื่องราชฯ
        /// <summary>
        /// 42-แบบ ขร4 บัญชีแสดงคุณสมบัติของข้าราชการซึ่งเสนอขอเครื่องราชฯ
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("42/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia42ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {
                var data = await _repository.GetKhr4Report(id);
                var YearInsignalPeriod = await _repository.GetYearInsigniaPeriod(id);
                var TwoYearInsignalPeriod = await _repository.Get2YearInsigniaPeriod(id);
                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }

                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"42-แบบ ขร4 บัญชีแสดงคุณสมบัติของข้าราชการซึ่งเสนอขอเครื่องราชฯ.trdp");
                ReportPackager reportPacker = new ReportPackager();
                Telerik.Reporting.Report? report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPacker.UnpackageDocument(sourceStream);
                }
                report.ReportParameters["YearInsigniaPeriod"].Value = YearInsignalPeriod;
                report.ReportParameters["TwoYearInsignalPeriod"].Value = TwoYearInsignalPeriod;

                var tbl1 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table1"];
                var _Khr4List = new List<dynamic>();
                foreach (var _data in data)
                {
                    _Khr4List.Add(new
                    {
                        RowNo = _Khr4List.Count + 1,
                        FullName = _data.GetType().GetProperty("FullName").GetValue(_data),
                        CitizenId = _data.GetType().GetProperty("CitizenId").GetValue(_data),
                        Type = _data.GetType().GetProperty("Type").GetValue(_data),
                        Level = _data.GetType().GetProperty("Level").GetValue(_data),
                        DateStart = _data.GetType().GetProperty("DateStart").GetValue(_data),
                        SalaryAmount = _data.GetType().GetProperty("SalaryAmount").GetValue(_data),
                        Position = _data.GetType().GetProperty("Position").GetValue(_data),
                        InsigniaRecv = _data.GetType().GetProperty("InsigniaRecv").GetValue(_data),
                        InsigniaRecvDate = _data.GetType().GetProperty("InsigniaRecvDate").GetValue(_data),
                        InsigniaRequest = _data.GetType().GetProperty("InsigniaRequest").GetValue(_data),
                        Remark = _data.GetType().GetProperty("Remark").GetValue(_data),
                    });
                }
                tbl1.DataSource = _Khr4List;

                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();
                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report,
                };
                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport($"{exportType}", instanceReportSource, deviceInfo);
                return File(result.DocumentBytes, mimeType, $"แบบ ขร4.{exportType.Trim().ToLower()}");

            }
            catch
            {
                throw;
            }
        }
        #endregion

        #region 43-บัญชีระดับผลการประเมินผลการปฏิบัติราชการในรอบ 5 ปี
        /// <summary>
        /// 43-บัญชีระดับผลการประเมินผลการปฏิบัติราชการในรอบ 5 ปี
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("43/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia43ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {

                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }

                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"43-บัญชีระดับผลการประเมินผลการปฏิบัติราชการในรอบ 5 ปี.trdp");
                var contentData = _reportGenerator.GenerateReport(rptFile, exportType);

                return File(contentData, mimeType, $"insignia.{exportType.Trim().ToLower()}");

            }
            catch
            {
                throw;
            }
        }
        #endregion

        #region 44-บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ
        /// <summary>
        /// 44-บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("44/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia44ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {
                var data = await _repository.GetSummaryCoinReport(id);
                var SummaryTotal = await _repository.GetSummaryTotalCoinReport(id);
                var YearInsignalPeriod = await _repository.GetYearInsigniaPeriod(id);
                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }

                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"44-บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ.trdp");
                ReportPackager reportPacker = new ReportPackager();
                Telerik.Reporting.Report? report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPacker.UnpackageDocument(sourceStream);
                }
                report.ReportParameters["YearInsigniaPeriod"].Value = YearInsignalPeriod;

                var tbl1 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table1"];
                var _Khr6List = new List<dynamic>();
                foreach (var _data in data)
                {
                    _Khr6List.Add(new
                    {
                        RowNo = _Khr6List.Count + 1,
                        DepartmentName = _data.GetType().GetProperty("DepartmentName").GetValue(_data),
                        G1Male = _data.GetType().GetProperty("G1Male").GetValue(_data),
                        G1Female = _data.GetType().GetProperty("G1Female").GetValue(_data),
                        G2Male = _data.GetType().GetProperty("G2Male").GetValue(_data),
                        G2Female = _data.GetType().GetProperty("G2Female").GetValue(_data),
                        Remark = _data.GetType().GetProperty("Remark").GetValue(_data),
                    });
                }
                tbl1.DataSource = _Khr6List;

                var tbl2 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table2"];
                tbl2.DataSource = SummaryTotal;
                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();
                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report,
                };
                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport($"{exportType}", instanceReportSource, deviceInfo);
                return File(result.DocumentBytes, mimeType, $"บัญชีแสดงจำนวนชั้นตราเครื่องราชฯ{exportType.Trim().ToLower()}");

            }
            catch
            {
                throw;
            }
        }
        #endregion

        #region 45-บัญชีแสดงรายชื่อผู้ขอพระราชทานเหรียญจักรพรรดิมาลา
        /// <summary>
        /// 45-บัญชีแสดงรายชื่อผู้ขอพระราชทานเหรียญจักรพรรดิมาลา
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("45/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia45ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {
                var data = await _repository.GetCoinReport(id);
                var YearInsignalPeriod = await _repository.GetYearInsigniaPeriod(id);
                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }

                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"45-บัญชีแสดงรายชื่อผู้ขอพระราชทานเหรียญจักรพรรดิมาลา.trdp");
                ReportPackager reportPacker = new ReportPackager();
                Telerik.Reporting.Report? report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPacker.UnpackageDocument(sourceStream);
                }

                report.ReportParameters["YearInsignalPeriod"].Value = YearInsignalPeriod;

                //var _Khr3List = new List<dynamic>();
                //int maxRows = 25;
                //for (int i = 0; i < maxRows; i++)
                //{
                //    _Khr3List.Add(new
                //    {
                //        RowNo = i + 1,
                //        FullName = string.Empty
                //    });
                //}

                //var tbl1 = (Telerik.Reporting.Table)report.Items["detailSection1"].Items["table1"];
                //tbl1.DataSource = _Khr3List;

                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();
                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report,
                };
                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport($"{exportType}", instanceReportSource, deviceInfo);
                return File(result.DocumentBytes, mimeType, $"บัญชีแสดงรายชื่อผู้ขอพระราชทานเหรียญจักรพรรดิมาลา.{exportType.Trim().ToLower()}");

            }
            catch
            {
                throw;
            }
        }
        #endregion

        #region 46-ประวัติสำหรับการเสนอขอพระราชทานเหรียญจักรพรรดิมาลา
        /// <summary>
        /// 46-ประวัติสำหรับการเสนอขอพระราชทานเหรียญจักรพรรดิมาลา
        /// </summary>
        /// <param name="id">id </param>
        /// <param name="exportType">pdf, docx หรือ xlsx</param>
        /// <returns></returns>
        /// <response code="200">เมื่อทำการอ่านข้อมูลจาก Relational Database สำเร็จ</response>
        /// <response code="401">ไม่ได้ Login เข้าระบบ</response>
        /// <response code="500">เมื่อเกิดข้อผิดพลาดในการทำงาน</response>
        [HttpGet("46/{exportType}/{id}")]
        public async Task<ActionResult<ResponseObject>> GetInsignia46ConvertReportAsync(Guid id, string exportType = "pdf")
        {
            try
            {
                var profile = await _repository.GetProfileInsignia(id);
                var data = await _repository.GetHistorySalaryReport(id);
                var mimeType = "";
                switch (exportType.Trim().ToLower())
                {
                    case "pdf": mimeType = "application/pdf"; break;
                    case "docx": mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
                    case "xlsx": mimeType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
                }

                var rptFile = System.IO.Path.Combine(_hostingEnvironment.ContentRootPath, "Reports", $"46-ประวัติสำหรับการเสนอขอพระราชทานเหรียญจักรพรรดิมาลา.trdp");
                ReportPackager reportPacker = new ReportPackager();
                Telerik.Reporting.Report? report = null;
                using (var sourceStream = System.IO.File.OpenRead(rptFile))
                {
                    report = (Telerik.Reporting.Report)reportPacker.UnpackageDocument(sourceStream);
                }

                report.ReportParameters["FullName"].Value = profile.GetType().GetProperty("FullName").GetValue(profile);
                report.ReportParameters["Position"].Value = profile.GetType().GetProperty("Position").GetValue(profile);
                report.ReportParameters["OCName"].Value = profile.GetType().GetProperty("OCName").GetValue(profile);
                report.ReportParameters["BirthDate"].Value = profile.GetType().GetProperty("BirthDate").GetValue(profile);

                var historysalary = new List<dynamic>();
                foreach (var _data in data)
                {
                    historysalary.Add(new
                    {
                        DateTh = _data.GetType().GetProperty("DateTh").GetValue(_data),
                        Position = _data.GetType().GetProperty("Position").GetValue(_data),
                        OCName = _data.GetType().GetProperty("OCName").GetValue(_data),
                        Age = _data.GetType().GetProperty("Age").GetValue(_data),
                        Amount = _data.GetType().GetProperty("Amount").GetValue(_data),
                        Remark = _data.GetType().GetProperty("Remark").GetValue(_data),
                    });
                }
                var tbl1 = (Telerik.Reporting.Table)report.Items["detailsection1"].Items["table1"];
                tbl1.DataSource = historysalary;

                System.Collections.Hashtable deviceInfo = new System.Collections.Hashtable();
                InstanceReportSource instanceReportSource = new InstanceReportSource()
                {
                    ReportDocument = report,
                };
                ReportProcessor reportProcessor = new ReportProcessor(_configuration);
                RenderingResult result = reportProcessor.RenderReport($"{exportType}", instanceReportSource, deviceInfo);
                return File(result.DocumentBytes, mimeType, $"ประวัติสำหรับการเสนอขอพระราชทานเหรียญจักรพรรดิมาลา.{exportType.Trim().ToLower()}");

            }
            catch
            {
                throw;
            }
        }
        #endregion

        #endregion
    }
}
